// (C) 2001-2024 Intel Corporation. All rights reserved.
// Your use of Intel Corporation's design tools, logic functions and other 
// software and tools, and its AMPP partner logic functions, and any output 
// files from any of the foregoing (including device programming or simulation 
// files), and any associated documentation or information are expressly subject 
// to the terms and conditions of the Intel Program License Subscription 
// Agreement, Intel FPGA IP License Agreement, or other applicable 
// license agreement, including, without limitation, that your use is for the 
// sole purpose of programming logic devices manufactured by Intel and sold by 
// Intel or its authorized distributors.  Please refer to the applicable 
// agreement for further details.


module bts_config (    
  input  wire        clk_gpio_p_4,    // system clock, 100M
  input  wire        fpga_resetn ,    //sysmax_pb[1] to trigger hard reset
  //I2C interfaces
  inout  wire			zl_i2c_scl_1v2          , //CH1, Access ZL30733, ZL_I2C_EN
  inout  wire			zl_i2c_sda_1v2          , 
  inout  wire			sdi_scl_1v2             , //CH2, Access LMH1218/LMH12189, CLK_I2C_EN0								
  inout  wire			sdi_sda_1v2				   , 
  inout  wire			i2c_qsfpdd0_scl         , //CH3, Access QSFPDD0, ZL_I2C_EN								
  inout  wire			i2c_qsfpdd0_sda			, 
  inout  wire			i2c_qsfpdd1_scl         , //CH4, Access	QSFPDD1							
  inout  wire			i2c_qsfpdd1_sda			,
  inout  wire			i2c_qsfpdd800_scl       , //CH5, Access	QSFPDD800							
  inout  wire			i2c_qsfpdd800_sda		   ,		
  inout  wire			ddr4_dimm_2_scl_1v2     , //CH6, Access	DIMM-A/DIMM-B							
  inout  wire			ddr4_dimm_2_sda_1v2		,
  inout  wire			vcxo_scl_1v2            , //CH7, Access	VCXO							
  inout  wire			vcxo_sda_1v2			   ,
  inout  wire			clk_i2c_scl_1v2			, //CH8, Access	CLOCK BUFFER			
  inout  wire			clk_i2c_sda_1v2			,
  inout  wire			i2c_fmca_scl			, //CH9, Access	FMC-A			
  inout  wire			i2c_fmca_sda			,
  inout  wire			i2c_fmcb_scl			, //CH10, Access FMC-B			
  inout  wire			i2c_fmcb_sda			,
  
//QSFPDD0/QSFPDD1/QSFPDD800    
  input  wire        qsfpp0_modprs_l		   , //ModPrsL is asserted low when the module is inserted 								
  input  wire        qsfpp1_modprs_l		   ,
  input  wire        qsfpp800_modprs_l		   ,
  output wire        qsfpdd0_modsel_l        , // When held low by the host, the module responds to 2-wire serial communication commands.                 
  output wire        qsfpdd1_modsel_l        ,
  output wire        qsfpdd800_modsel_l      ,
 
//SGPIO for dipsw, leds
  input  wire        fpga_sgpio_sync,
  input  wire        fpga_sgpio_clk ,
  input  wire        fpga_sgpi      ,    
  output wire        fpga_sgpo      ,
//f_gpio 
  input  wire        f_gpio0,    //user_pb0
  input  wire        f_gpio1,    //user_pb1
  output wire        f_gpio2,    //MCIO_PERST in RP Mode
  output wire        f_gpio3,    //FMC_A PERST in RP Mode
  output wire        f_gpio4,    //FMC_B PERST in RP Mode
//inc_dec_pulse
  output wire        inc_pulse,
  output wire        dec_pulse
  
);
wire            ninit_done;	
wire            S_global_resetn;	  
wire            clk_50m;
wire            clk_25m;
wire [7:0]      fpga_sw;
wire [7:0]      fpga_led;
wire [1:0]      fpga_pb;  
		        
//wire [2:0]      receiver_irq;
wire [10:0] 	 S_inc_num    ; 
wire [10:0] 	 S_dec_num    ; 
wire            S_clr_inc_num;
wire            S_clr_dec_num;
wire [15:0]     S_state_data ;
wire          zl_i2c_scl_1v2_in        ;
wire          zl_i2c_sda_1v2_in        ;
wire          zl_i2c_scl_1v2_oe        ;
wire          zl_i2c_sda_1v2_oe        ;             
wire          sdi_scl_1v2_in           ;
wire          sdi_sda_1v2_in		      ;
wire          sdi_scl_1v2_oe           ;
wire          sdi_sda_1v2_oe		      ;
wire          ddr4_dimm_2_scl_1v2_in   ;
wire          ddr4_dimm_2_sda_1v2_in   ;
wire          ddr4_dimm_2_scl_1v2_oe   ;
wire          ddr4_dimm_2_sda_1v2_oe   ;
wire          vcxo_scl_1v2_in          ;
wire          vcxo_sda_1v2_in		      ;
wire          vcxo_scl_1v2_oe          ;
wire          vcxo_sda_1v2_oe		      ;
wire          clk_i2c_scl_1v2_in	      ;
wire          clk_i2c_sda_1v2_in	      ;
wire          clk_i2c_scl_1v2_oe	      ;
wire          clk_i2c_sda_1v2_oe	      ;
// I2C of QSFPDDx
wire          i2c_qsfpdd0_scl_in       ;
wire          i2c_qsfpdd0_sda_in	      ;
wire          i2c_qsfpdd0_scl_oe       ;
wire          i2c_qsfpdd0_sda_oe	      ;
wire          i2c_qsfpdd1_scl_in       ;
wire          i2c_qsfpdd1_sda_in	      ;
wire          i2c_qsfpdd1_scl_oe       ;
wire          i2c_qsfpdd1_sda_oe	      ;
wire          i2c_qsfpdd800_scl_in     ;
wire          i2c_qsfpdd800_sda_in	   ;
wire          i2c_qsfpdd800_scl_oe     ;
wire          i2c_qsfpdd800_sda_oe	   ;
wire          i2c_fmca_scl_in       ;
wire          i2c_fmca_sda_in	      ;
wire          i2c_fmca_scl_oe       ;
wire          i2c_fmca_sda_oe	      ;
											  
wire          i2c_fmcb_scl_in       ;
wire          i2c_fmcb_sda_in	      ;
wire          i2c_fmcb_scl_oe       ;
wire          i2c_fmcb_sda_oe	      ;
											  
assign fpga_pb = {f_gpio1,f_gpio0};
assign S_global_resetn = !ninit_done && fpga_resetn; //nINIT_DONE is high until the entire device enters user mode
assign f_gpio2 = 1'b1;
assign f_gpio3 = 1'b1;
assign f_gpio4 = 1'b1;
assign qsfpdd0_modsel_l = qsfpp0_modprs_l ? 1'b1 : 1'b0;
assign qsfpdd1_modsel_l = qsfpp1_modprs_l ? 1'b1 : 1'b0;
assign qsfpdd800_modsel_l = qsfpp800_modprs_l ? 1'b1 : 1'b0;
		  
  reset_release reset_release (
	.ninit_done(ninit_done)
	);
 
  sys_pll sys_pll_inst(
  	.rst      (!S_global_resetn), 
  	.refclk   (clk_gpio_p_4    ),
  	.locked   (  ),
  	.outclk_0 (clk_50m         ),
	.outclk_1 (clk_25m         )
  	); 
	
  pulse_generate pulse_generate_inst(
    .rst_n       (S_global_resetn),
    .clk         (clk_25m        ),
    .inc_num     (S_inc_num      ),
    .dec_num     (S_dec_num      ),
    .inc_pulse   (inc_pulse      ),
    .dec_pulse   (dec_pulse      ),
    .clr_inc_num (S_clr_inc_num  ),
	 .clr_dec_num (S_clr_dec_num  ),
	 .state_data  (S_state_data   )
  );
  
  sgpio_slave sgpio_slave_inst(
    .i_rstn     (S_global_resetn ),
    .i_clk      (fpga_sgpio_clk  ),
    .i_sync     (fpga_sgpio_sync ),
    .i_mosi     (fpga_sgpi       ),
    .o_miso     (fpga_sgpo       ),
    .o_user_sw  (fpga_sw         ),
    .i_user_led (fpga_led        )
  );
  
  q_sys q_sys_inst(                                                               
      .system_max_id_1_conduit_version             (S_state_data            ),             //   input,  width = 16,              system_max_id_1_conduit.version
		.system_max_id_1_conduit_clr_dec_num         (S_clr_dec_num           ),         //   input,   width = 1,                                     .clr_dec_num
		.system_max_id_1_conduit_clr_inc_num         (S_clr_inc_num           ),         //   input,   width = 1,                                     .clr_inc_num
		.system_max_id_1_conduit_dec_num             (S_dec_num               ),             //  output,  width = 11,                                     .dec_num
		.system_max_id_1_conduit_inc_num             (S_inc_num               ),             //  output,  width = 11,                                     .inc_num
		.system_max_id_1_conduit_control_gui         (                        ),         //  output,  width = 16,                                     .control_gui
		.clk_clk                                     (clk_50m                 ),                                     //   input,   width = 1,                                  clk.clk
		.reset_reset_n                               (S_global_resetn         ),                               //   input,   width = 1,                                reset.reset_n
		.i2c_0_i2c_serial_sda_in                     (zl_i2c_sda_1v2_in       ),                     //   input,   width = 1,                     i2c_0_i2c_serial.sda_in
		.i2c_0_i2c_serial_scl_in                     (zl_i2c_scl_1v2_in       ),                     //   input,   width = 1,                                     .scl_in
		.i2c_0_i2c_serial_sda_oe                     (zl_i2c_sda_1v2_oe       ),                     //  output,   width = 1,                                     .sda_oe
		.i2c_0_i2c_serial_scl_oe                     (zl_i2c_scl_1v2_oe       ),                     //  output,   width = 1,                                     .scl_oe
		.i2c_1_i2c_serial_sda_in                     (sdi_sda_1v2_in          ),                     //   input,   width = 1,                     i2c_1_i2c_serial.sda_in
		.i2c_1_i2c_serial_scl_in                     (sdi_scl_1v2_in	       ),                     //   input,   width = 1,                                     .scl_in
		.i2c_1_i2c_serial_sda_oe                     (sdi_sda_1v2_oe          ),                     //  output,   width = 1,                                     .sda_oe
		.i2c_1_i2c_serial_scl_oe                     (sdi_scl_1v2_oe	       ),                     //  output,   width = 1,                                     .scl_oe
		.i2c_2_i2c_serial_sda_in                     (i2c_qsfpdd0_sda_in      ),                     //   input,   width = 1,                     i2c_2_i2c_serial.sda_in
		.i2c_2_i2c_serial_scl_in                     (i2c_qsfpdd0_scl_in      ),                     //   input,   width = 1,                                     .scl_in
		.i2c_2_i2c_serial_sda_oe                     (i2c_qsfpdd0_sda_oe      ),                     //  output,   width = 1,                                     .sda_oe
		.i2c_2_i2c_serial_scl_oe                     (i2c_qsfpdd0_scl_oe      ),                     //  output,   width = 1,                                     .scl_oe
		.i2c_3_i2c_serial_sda_in                     (i2c_qsfpdd1_sda_in      ),                     //   input,   width = 1,                     i2c_3_i2c_serial.sda_in
		.i2c_3_i2c_serial_scl_in                     (i2c_qsfpdd1_scl_in      ),                     //   input,   width = 1,                                     .scl_in
		.i2c_3_i2c_serial_sda_oe                     (i2c_qsfpdd1_sda_oe      ),                     //  output,   width = 1,                                     .sda_oe
		.i2c_3_i2c_serial_scl_oe                     (i2c_qsfpdd1_scl_oe      ),                     //  output,   width = 1,                                     .scl_oe
		.i2c_4_i2c_serial_sda_in                     (i2c_qsfpdd800_sda_in    ),                     //   input,   width = 1,                     i2c_4_i2c_serial.sda_in
		.i2c_4_i2c_serial_scl_in                     (i2c_qsfpdd800_scl_in    ),                     //   input,   width = 1,                                     .scl_in
		.i2c_4_i2c_serial_sda_oe                     (i2c_qsfpdd800_sda_oe    ),                     //  output,   width = 1,                                     .sda_oe
		.i2c_4_i2c_serial_scl_oe                     (i2c_qsfpdd800_scl_oe    ),                     //  output,   width = 1,                                     .scl_oe
		.i2c_5_i2c_serial_sda_in                     (ddr4_dimm_2_sda_1v2_in  ),                     //   input,   width = 1,                     i2c_5_i2c_serial.sda_in
		.i2c_5_i2c_serial_scl_in                     (ddr4_dimm_2_scl_1v2_in  ),                     //   input,   width = 1,                                     .scl_in
		.i2c_5_i2c_serial_sda_oe                     (ddr4_dimm_2_sda_1v2_oe  ),                     //  output,   width = 1,                                     .sda_oe
		.i2c_5_i2c_serial_scl_oe                     (ddr4_dimm_2_scl_1v2_oe  ),                     //  output,   width = 1,                                     .scl_oe
		.i2c_6_i2c_serial_sda_in                     (vcxo_sda_1v2_in         ),                     //   input,   width = 1,                     i2c_6_i2c_serial.sda_in
		.i2c_6_i2c_serial_scl_in                     (vcxo_scl_1v2_in	       ),                     //   input,   width = 1,                                     .scl_in
		.i2c_6_i2c_serial_sda_oe                     (vcxo_sda_1v2_oe         ),                     //  output,   width = 1,                                     .sda_oe
		.i2c_6_i2c_serial_scl_oe                     (vcxo_scl_1v2_oe		    ),                     //  output,   width = 1,                                     .scl_oe
		.i2c_7_i2c_serial_sda_in                     (clk_i2c_sda_1v2_in	    ),                     //   input,   width = 1,                     i2c_7_i2c_serial.sda_in
		.i2c_7_i2c_serial_scl_in                     (clk_i2c_scl_1v2_in      ),                     //   input,   width = 1,                                     .scl_in
		.i2c_7_i2c_serial_sda_oe                     (clk_i2c_sda_1v2_oe	    ),                     //  output,   width = 1,                                     .sda_oe
		.i2c_7_i2c_serial_scl_oe                     (clk_i2c_scl_1v2_oe	    ),                     //  output,   width = 1,                                     .scl_oe
		.i2c_8_i2c_serial_sda_in                     (i2c_fmca_sda_in    ),                     //   input,   width = 1,                     i2c_8_i2c_serial.sda_in
		.i2c_8_i2c_serial_scl_in                     (i2c_fmca_scl_in    ),                     //   input,   width = 1,                                     .scl_in
		.i2c_8_i2c_serial_sda_oe                     (i2c_fmca_sda_oe    ),                     //  output,   width = 1,                                     .sda_oe
		.i2c_8_i2c_serial_scl_oe                     (i2c_fmca_scl_oe    ),                     //  output,   width = 1,  
		.i2c_9_i2c_serial_sda_in                     (i2c_fmcb_sda_in    ),                     //   input,   width = 1,                     i2c_9_i2c_serial.sda_in
		.i2c_9_i2c_serial_scl_in                     (i2c_fmcb_scl_in    ),                     //   input,   width = 1,                                     .scl_in
		.i2c_9_i2c_serial_sda_oe                     (i2c_fmcb_sda_oe    ),                     //  output,   width = 1,                                     .sda_oe
		.i2c_9_i2c_serial_scl_oe                     (i2c_fmcb_scl_oe    ),                     //  output,   width = 1,  
		.pio_0_user_led_external_connection_export   (fpga_led                ),   //  output,   width = 8,   pio_0_user_led_external_connection.export
		.pio_1_user_dipsw_external_connection_export (fpga_sw                 ), //   input,   width = 8, pio_1_user_dipsw_external_connection.export
		.pio_2_user_pb_external_connection_export    (fpga_pb                 )    //   input,   width = 2,    pio_2_user_pb_external_connection.export
);		                                                                    
assign zl_i2c_scl_1v2_in             = zl_i2c_scl_1v2;
assign zl_i2c_sda_1v2_in             = zl_i2c_sda_1v2;
assign zl_i2c_scl_1v2                = zl_i2c_scl_1v2_oe ? 1'b0 : 1'bz;
assign zl_i2c_sda_1v2                = zl_i2c_sda_1v2_oe ? 1'b0 : 1'bz;
								     
assign sdi_scl_1v2_in                = sdi_scl_1v2;
assign sdi_sda_1v2_in                = sdi_sda_1v2;
assign sdi_scl_1v2                   = sdi_scl_1v2_oe ? 1'b0 : 1'bz;
assign sdi_sda_1v2                   = sdi_sda_1v2_oe ? 1'b0 : 1'bz;
								     
assign ddr4_dimm_2_scl_1v2_in        = ddr4_dimm_2_scl_1v2;
assign ddr4_dimm_2_sda_1v2_in        = ddr4_dimm_2_sda_1v2;
assign ddr4_dimm_2_scl_1v2           = ddr4_dimm_2_scl_1v2_oe ? 1'b0 : 1'bz;
assign ddr4_dimm_2_sda_1v2           = ddr4_dimm_2_sda_1v2_oe ? 1'b0 : 1'bz;
assign vcxo_scl_1v2_in               = vcxo_scl_1v2;
assign vcxo_sda_1v2_in               = vcxo_sda_1v2;
assign vcxo_scl_1v2                  = vcxo_scl_1v2_oe ? 1'b0 : 1'bz;
assign vcxo_sda_1v2                  = vcxo_sda_1v2_oe ? 1'b0 : 1'bz;
assign clk_i2c_scl_1v2_in            = clk_i2c_scl_1v2;
assign clk_i2c_sda_1v2_in            = clk_i2c_sda_1v2;
assign clk_i2c_scl_1v2               = clk_i2c_scl_1v2_oe ? 1'b0 : 1'bz;
assign clk_i2c_sda_1v2               = clk_i2c_sda_1v2_oe ? 1'b0 : 1'bz;
assign i2c_fmcb_scl_in = i2c_fmcb_scl;
assign i2c_fmcb_sda_in = i2c_fmcb_sda;
assign i2c_fmcb_scl    = i2c_fmcb_scl_oe ? 1'b0 : 1'bz;
assign i2c_fmcb_sda    = i2c_fmcb_sda_oe ? 1'b0 : 1'bz;
assign i2c_fmca_scl_in = i2c_fmca_scl;
assign i2c_fmca_sda_in = i2c_fmca_sda;
assign i2c_fmca_scl    = i2c_fmca_scl_oe ? 1'b0 : 1'bz;
assign i2c_fmca_sda    = i2c_fmca_sda_oe ? 1'b0 : 1'bz;
// QSFPDDx
assign i2c_qsfpdd0_scl_in   = i2c_qsfpdd0_scl;
assign i2c_qsfpdd0_sda_in   = i2c_qsfpdd0_sda;
assign i2c_qsfpdd0_scl      = i2c_qsfpdd0_scl_oe ? 1'b0 : 1'bz;
assign i2c_qsfpdd0_sda      = i2c_qsfpdd0_sda_oe ? 1'b0 : 1'bz;
							       
assign i2c_qsfpdd1_scl_in   = i2c_qsfpdd1_scl;
assign i2c_qsfpdd1_sda_in   = i2c_qsfpdd1_sda;
assign i2c_qsfpdd1_scl      = i2c_qsfpdd1_scl_oe ? 1'b0 : 1'bz;
assign i2c_qsfpdd1_sda      = i2c_qsfpdd1_sda_oe ? 1'b0 : 1'bz;
assign i2c_qsfpdd800_scl_in = i2c_qsfpdd800_scl;
assign i2c_qsfpdd800_sda_in = i2c_qsfpdd800_sda;
assign i2c_qsfpdd800_scl    = i2c_qsfpdd800_scl_oe ? 1'b0 : 1'bz;
assign i2c_qsfpdd800_sda    = i2c_qsfpdd800_sda_oe ? 1'b0 : 1'bz;
endmodule	
	