# Copyright (C) 2001-2025 Altera Corporation
#
# This code and the related documents are Altera copyrighted materials and
# your use of them is governed by the express license under which they were
# provided to you ("License"). Unless the License provides otherwise, you may
# not use, modify, copy, publish, distribute, disclose, or transmit this
# code or the related documents without Altera's prior written permission.
# 
# This code and the related documents are provided as is, with no express
# or implied warranties other than those that are expressly stated in the
# License.


# TCL File Generated by Component Editor 12.0
# Tue Jun 05 13:05:30 PDT 2012
# DO NOT MODIFY
# 
# master_driver_msgdma "master_driver_msgdma" v1.0
# null 2012.06.05.13:05:30
# H/W driver to control the DMA
# 
# 
# request TCL package from ACDS 12.0
# 
package require -exact qsys 12.0
# 
# module master_driver_msgdma
# 
set_module_property DESCRIPTION "H/W driver to control the DMA"
set_module_property NAME master_driver_msgdma
set_module_property VERSION 1.0
set_module_property INTERNAL false
set_module_property OPAQUE_ADDRESS_MAP true
set_module_property GROUP BoardTestSystem
set_module_property DISPLAY_NAME master_driver_msgdma
set_module_property INSTANTIATE_IN_SYSTEM_MODULE true
set_module_property EDITABLE true
set_module_property ANALYZE_HDL AUTO
set_module_property REPORT_TO_TALKBACK false
set_module_property ALLOW_GREYBOX_GENERATION false
# 
# file sets
# 
add_fileset quartus_synth QUARTUS_SYNTH "" "Quartus Synthesis"
set_fileset_property quartus_synth TOP_LEVEL master_driver_msgdma
set_fileset_property quartus_synth ENABLE_RELATIVE_INCLUDE_PATHS false
add_fileset_file master_driver_msgdma.v VERILOG PATH master_driver_msgdma.v
#add_fileset_file master_driver.sdc SDC PATH master_driver.sdc
add_fileset sim_verilog SIM_VERILOG "" "Verilog Simulation"
set_fileset_property sim_verilog TOP_LEVEL master_driver_msgdma
set_fileset_property sim_verilog ENABLE_RELATIVE_INCLUDE_PATHS false
add_fileset_file master_driver_msgdma.v VERILOG PATH master_driver_msgdma.v
# 
# parameters
# 
add_parameter DUT_MEMORY_BASE_ADDRESS STD_LOGIC_VECTOR 0 "Specify the Qsys base address of DUT memory module"
set_parameter_property DUT_MEMORY_BASE_ADDRESS DEFAULT_VALUE 0
set_parameter_property DUT_MEMORY_BASE_ADDRESS DISPLAY_NAME DUT_MEMORY_BASE_ADDRESS
set_parameter_property DUT_MEMORY_BASE_ADDRESS WIDTH 40
set_parameter_property DUT_MEMORY_BASE_ADDRESS TYPE STD_LOGIC_VECTOR
set_parameter_property DUT_MEMORY_BASE_ADDRESS UNITS None
set_parameter_property DUT_MEMORY_BASE_ADDRESS ALLOWED_RANGES 0:1099511627775
set_parameter_property DUT_MEMORY_BASE_ADDRESS DESCRIPTION "Specify the Qsys base address of DUT memory module"
set_parameter_property DUT_MEMORY_BASE_ADDRESS HDL_PARAMETER true
add_parameter DUT_MEMORY_TOTAL_SIZE STD_LOGIC_VECTOR 8589934592 "Specify the total size of DUT memory module in bytes"
set_parameter_property DUT_MEMORY_TOTAL_SIZE DEFAULT_VALUE 8589934592
set_parameter_property DUT_MEMORY_TOTAL_SIZE DISPLAY_NAME DUT_MEMORY_TOTAL_SIZE
set_parameter_property DUT_MEMORY_TOTAL_SIZE WIDTH 40
set_parameter_property DUT_MEMORY_TOTAL_SIZE TYPE STD_LOGIC_VECTOR
set_parameter_property DUT_MEMORY_TOTAL_SIZE UNITS None
set_parameter_property DUT_MEMORY_TOTAL_SIZE ALLOWED_RANGES 0:1099511627775
set_parameter_property DUT_MEMORY_TOTAL_SIZE DESCRIPTION "Specify the total size of DUT memory module in bytes"
set_parameter_property DUT_MEMORY_TOTAL_SIZE HDL_PARAMETER true
add_parameter DUT_MEMORY_TEST_SIZE STD_LOGIC_VECTOR 8589934592 "Specify the test size of DUT memory module in bytes"
set_parameter_property DUT_MEMORY_TEST_SIZE DEFAULT_VALUE 8589934592
set_parameter_property DUT_MEMORY_TEST_SIZE DISPLAY_NAME DUT_MEMORY_TEST_SIZE
set_parameter_property DUT_MEMORY_TEST_SIZE WIDTH 40
set_parameter_property DUT_MEMORY_TEST_SIZE TYPE STD_LOGIC_VECTOR
set_parameter_property DUT_MEMORY_TEST_SIZE UNITS None
set_parameter_property DUT_MEMORY_TEST_SIZE ALLOWED_RANGES 0:1099511627775
set_parameter_property DUT_MEMORY_TEST_SIZE DESCRIPTION "Specify the test size of DUT memory module in bytes"
set_parameter_property DUT_MEMORY_TEST_SIZE HDL_PARAMETER true
add_parameter DUT_MEMORY_TEST_OFFSET_ADDRESS STD_LOGIC_VECTOR 0 "Specify the test start address of DUT memory module in bytes"
set_parameter_property DUT_MEMORY_TEST_OFFSET_ADDRESS DEFAULT_VALUE 0
set_parameter_property DUT_MEMORY_TEST_OFFSET_ADDRESS DISPLAY_NAME DUT_MEMORY_TEST_OFFSET_ADDRESS
set_parameter_property DUT_MEMORY_TEST_OFFSET_ADDRESS WIDTH 40
set_parameter_property DUT_MEMORY_TEST_OFFSET_ADDRESS TYPE STD_LOGIC_VECTOR
set_parameter_property DUT_MEMORY_TEST_OFFSET_ADDRESS UNITS None
set_parameter_property DUT_MEMORY_TEST_OFFSET_ADDRESS ALLOWED_RANGES 0:68719476735
set_parameter_property DUT_MEMORY_TEST_OFFSET_ADDRESS DESCRIPTION "Specify the test start address of DUT memory module in bytes"
set_parameter_property DUT_MEMORY_TEST_OFFSET_ADDRESS HDL_PARAMETER true
add_parameter MSGDMA_QSYS_BASE_ADDRESS STD_LOGIC_VECTOR 0 "Specify the Qsys base address of mSGDMA component"
set_parameter_property MSGDMA_QSYS_BASE_ADDRESS DEFAULT_VALUE 0
set_parameter_property MSGDMA_QSYS_BASE_ADDRESS DISPLAY_NAME MSGDMA_QSYS_BASE_ADDRESS
set_parameter_property MSGDMA_QSYS_BASE_ADDRESS WIDTH 32
set_parameter_property MSGDMA_QSYS_BASE_ADDRESS TYPE STD_LOGIC_VECTOR
set_parameter_property MSGDMA_QSYS_BASE_ADDRESS UNITS None
set_parameter_property MSGDMA_QSYS_BASE_ADDRESS ALLOWED_RANGES 0:4294967295
set_parameter_property MSGDMA_QSYS_BASE_ADDRESS DESCRIPTION "Specify the Qsys base address of mSGDMA component"
set_parameter_property MSGDMA_QSYS_BASE_ADDRESS HDL_PARAMETER true
add_parameter MSGDMA_DISP_WRITE_CSR_OFFSET STD_LOGIC_VECTOR 192 "Specify the Qsys offset address of dispatcher CSR write module in mSGDMA component"
set_parameter_property MSGDMA_DISP_WRITE_CSR_OFFSET DEFAULT_VALUE 192
set_parameter_property MSGDMA_DISP_WRITE_CSR_OFFSET DISPLAY_NAME MSGDMA_DISP_WRITE_CSR_OFFSET
set_parameter_property MSGDMA_DISP_WRITE_CSR_OFFSET WIDTH 32
set_parameter_property MSGDMA_DISP_WRITE_CSR_OFFSET TYPE STD_LOGIC_VECTOR
set_parameter_property MSGDMA_DISP_WRITE_CSR_OFFSET UNITS None
set_parameter_property MSGDMA_DISP_WRITE_CSR_OFFSET ALLOWED_RANGES 0:4294967295
set_parameter_property MSGDMA_DISP_WRITE_CSR_OFFSET DESCRIPTION "Specify the Qsys offset address of dispatcher CSR write module in mSGDMA component"
set_parameter_property MSGDMA_DISP_WRITE_CSR_OFFSET HDL_PARAMETER true
add_parameter MSGDMA_DISP_WRITE_DESCRIPTOR_OFFSET STD_LOGIC_VECTOR 224 "Specify the Qsys offset address of dispatcher descriptor write module in mSGDMA component"
set_parameter_property MSGDMA_DISP_WRITE_DESCRIPTOR_OFFSET DEFAULT_VALUE 224
set_parameter_property MSGDMA_DISP_WRITE_DESCRIPTOR_OFFSET DISPLAY_NAME MSGDMA_DISP_WRITE_DESCRIPTOR_OFFSET
set_parameter_property MSGDMA_DISP_WRITE_DESCRIPTOR_OFFSET WIDTH 32
set_parameter_property MSGDMA_DISP_WRITE_DESCRIPTOR_OFFSET TYPE STD_LOGIC_VECTOR
set_parameter_property MSGDMA_DISP_WRITE_DESCRIPTOR_OFFSET UNITS None
set_parameter_property MSGDMA_DISP_WRITE_DESCRIPTOR_OFFSET ALLOWED_RANGES 0:4294967295
set_parameter_property MSGDMA_DISP_WRITE_DESCRIPTOR_OFFSET DESCRIPTION "Specify the Qsys offset address of dispatcher descriptor write module in mSGDMA component"
set_parameter_property MSGDMA_DISP_WRITE_DESCRIPTOR_OFFSET HDL_PARAMETER true
add_parameter MSGDMA_DISP_READ_CSR_OFFSET STD_LOGIC_VECTOR 128 "Specify the Qsys offset address of dispatcher CSR read interface in mSGDMA component"
set_parameter_property MSGDMA_DISP_READ_CSR_OFFSET DEFAULT_VALUE 128
set_parameter_property MSGDMA_DISP_READ_CSR_OFFSET DISPLAY_NAME MSGDMA_DISP_READ_CSR_OFFSET
set_parameter_property MSGDMA_DISP_READ_CSR_OFFSET WIDTH 32
set_parameter_property MSGDMA_DISP_READ_CSR_OFFSET TYPE STD_LOGIC_VECTOR
set_parameter_property MSGDMA_DISP_READ_CSR_OFFSET UNITS None
set_parameter_property MSGDMA_DISP_READ_CSR_OFFSET ALLOWED_RANGES 0:4294967295
set_parameter_property MSGDMA_DISP_READ_CSR_OFFSET DESCRIPTION "Specify the Qsys offset address of dispatcher CSR read interface in mSGDMA component"
set_parameter_property MSGDMA_DISP_READ_CSR_OFFSET HDL_PARAMETER true
add_parameter MSGDMA_DISP_READ_DESCRIPTOR_OFFSET STD_LOGIC_VECTOR 160 "Specify the Qsys offset address of dispatcher descriptor read interface in mSGDMA component"
set_parameter_property MSGDMA_DISP_READ_DESCRIPTOR_OFFSET DEFAULT_VALUE 160
set_parameter_property MSGDMA_DISP_READ_DESCRIPTOR_OFFSET DISPLAY_NAME MSGDMA_DISP_READ_DESCRIPTOR_OFFSET
set_parameter_property MSGDMA_DISP_READ_DESCRIPTOR_OFFSET WIDTH 32
set_parameter_property MSGDMA_DISP_READ_DESCRIPTOR_OFFSET TYPE STD_LOGIC_VECTOR
set_parameter_property MSGDMA_DISP_READ_DESCRIPTOR_OFFSET UNITS None
set_parameter_property MSGDMA_DISP_READ_DESCRIPTOR_OFFSET ALLOWED_RANGES 0:4294967295
set_parameter_property MSGDMA_DISP_READ_DESCRIPTOR_OFFSET DESCRIPTION "Specify the Qsys offset address of dispatcher descriptor read interface in mSGDMA component"
set_parameter_property MSGDMA_DISP_READ_DESCRIPTOR_OFFSET HDL_PARAMETER true
#add_parameter MSGDMA_TIMER_OFFSET STD_LOGIC_VECTOR 352 "Specify the Qsys offset address of timer module in mSGDMA component"
#set_parameter_property MSGDMA_TIMER_OFFSET DEFAULT_VALUE 352
#set_parameter_property MSGDMA_TIMER_OFFSET DISPLAY_NAME MSGDMA_TIMER_OFFSET
#set_parameter_property MSGDMA_TIMER_OFFSET WIDTH 32
#set_parameter_property MSGDMA_TIMER_OFFSET TYPE STD_LOGIC_VECTOR
#set_parameter_property MSGDMA_TIMER_OFFSET UNITS None
#set_parameter_property MSGDMA_TIMER_OFFSET ALLOWED_RANGES 0:4294967295
#set_parameter_property MSGDMA_TIMER_OFFSET DESCRIPTION "Specify the Qsys offset address of timer module in mSGDMA component"
#set_parameter_property MSGDMA_TIMER_OFFSET HDL_PARAMETER true
add_parameter MSGDMA_FREQ_COUNTER_OFFSET STD_LOGIC_VECTOR 256 "Specify the Qsys offset address of frequency counter module in mSGDMA component"
set_parameter_property MSGDMA_FREQ_COUNTER_OFFSET DEFAULT_VALUE 256
set_parameter_property MSGDMA_FREQ_COUNTER_OFFSET DISPLAY_NAME MSGDMA_FREQ_COUNTER_OFFSET
set_parameter_property MSGDMA_FREQ_COUNTER_OFFSET WIDTH 32
set_parameter_property MSGDMA_FREQ_COUNTER_OFFSET TYPE STD_LOGIC_VECTOR
set_parameter_property MSGDMA_FREQ_COUNTER_OFFSET UNITS None
set_parameter_property MSGDMA_FREQ_COUNTER_OFFSET ALLOWED_RANGES 0:4294967295
set_parameter_property MSGDMA_FREQ_COUNTER_OFFSET DESCRIPTION "Specify the Qsys offset address of frequency counter module in mSGDMA component"
set_parameter_property MSGDMA_FREQ_COUNTER_OFFSET HDL_PARAMETER true
add_parameter MSGDMA_PRBS_PATTERN_GEN_OFFSET STD_LOGIC_VECTOR 64 "Specify the Qsys offset address of PRBS Generator module in mSGDMA component"
set_parameter_property MSGDMA_PRBS_PATTERN_GEN_OFFSET DEFAULT_VALUE 64
set_parameter_property MSGDMA_PRBS_PATTERN_GEN_OFFSET DISPLAY_NAME MSGDMA_PRBS_PATTERN_GEN_OFFSET
set_parameter_property MSGDMA_PRBS_PATTERN_GEN_OFFSET WIDTH 32
set_parameter_property MSGDMA_PRBS_PATTERN_GEN_OFFSET TYPE STD_LOGIC_VECTOR
set_parameter_property MSGDMA_PRBS_PATTERN_GEN_OFFSET UNITS None
set_parameter_property MSGDMA_PRBS_PATTERN_GEN_OFFSET ALLOWED_RANGES 0:4294967295
set_parameter_property MSGDMA_PRBS_PATTERN_GEN_OFFSET DESCRIPTION "Specify the Qsys offset address of PRBS Generator module in mSGDMA component"
set_parameter_property MSGDMA_PRBS_PATTERN_GEN_OFFSET HDL_PARAMETER true
add_parameter MSGDMA_PRBS_PATTERN_CHK_OFFSET STD_LOGIC_VECTOR 0 "Specify the Qsys offset address of PRBS checker module in mSGDMA component"
set_parameter_property MSGDMA_PRBS_PATTERN_CHK_OFFSET DEFAULT_VALUE 0
set_parameter_property MSGDMA_PRBS_PATTERN_CHK_OFFSET DISPLAY_NAME MSGDMA_PRBS_PATTERN_CHK_OFFSET
set_parameter_property MSGDMA_PRBS_PATTERN_CHK_OFFSET WIDTH 32
set_parameter_property MSGDMA_PRBS_PATTERN_CHK_OFFSET TYPE STD_LOGIC_VECTOR
set_parameter_property MSGDMA_PRBS_PATTERN_CHK_OFFSET UNITS None
set_parameter_property MSGDMA_PRBS_PATTERN_CHK_OFFSET ALLOWED_RANGES 0:4294967295
set_parameter_property MSGDMA_PRBS_PATTERN_CHK_OFFSET DESCRIPTION "Specify the Qsys offset address of PRBS checker module in mSGDMA component"
set_parameter_property MSGDMA_PRBS_PATTERN_CHK_OFFSET HDL_PARAMETER true
add_parameter PRBS_WIDTH INTEGER 64
set_parameter_property PRBS_WIDTH DEFAULT_VALUE 64
set_parameter_property PRBS_WIDTH DISPLAY_NAME "MSGDMA_PRBS_WIDTH"
set_parameter_property PRBS_WIDTH UNITS None
set_parameter_property PRBS_WIDTH ALLOWED_RANGES {8 16 32 64 128}
set_parameter_property PRBS_WIDTH DESCRIPTION "PRBS width in line with pattern generator/checker in mSGDMA module"
set_parameter_property PRBS_WIDTH DISPLAY_HINT ""
set_parameter_property PRBS_WIDTH AFFECTS_GENERATION false
set_parameter_property PRBS_WIDTH HDL_PARAMETER true
add_parameter DATA_WIDTH INTEGER 512
set_parameter_property DATA_WIDTH DEFAULT_VALUE 512
set_parameter_property DATA_WIDTH DISPLAY_NAME "MSGDMA_DATA_WIDTH"
set_parameter_property DATA_WIDTH UNITS None
set_parameter_property DATA_WIDTH ALLOWED_RANGES {8 16 32 64 128 256 512 1024}
set_parameter_property DATA_WIDTH DESCRIPTION "Data width in line with EMIF AVMM SLAVE (CTRL_AMM_0) WIDTH"
set_parameter_property DATA_WIDTH DISPLAY_HINT ""
set_parameter_property DATA_WIDTH AFFECTS_GENERATION false
set_parameter_property DATA_WIDTH HDL_PARAMETER true
add_parameter MAX_BURST_COUNT INTEGER 32
set_parameter_property MAX_BURST_COUNT DEFAULT_VALUE 32
set_parameter_property MAX_BURST_COUNT DISPLAY_NAME "MSGDMA_MAX_BURST_COUNT"
set_parameter_property MAX_BURST_COUNT UNITS None
set_parameter_property MAX_BURST_COUNT ALLOWED_RANGES {2 4 8 16 32 64 128 256 512 1024}
set_parameter_property MAX_BURST_COUNT DESCRIPTION "Maximum burst count in line with the ones defined in Read/Write Master in mSGDMA module"
set_parameter_property MAX_BURST_COUNT DISPLAY_HINT ""
set_parameter_property MAX_BURST_COUNT AFFECTS_GENERATION false
set_parameter_property MAX_BURST_COUNT HDL_PARAMETER true
add_parameter LOCAL_DATA_WORDS STD_LOGIC_VECTOR 64 "Specify the Qsys EMIF core local data width in bytes"
set_parameter_property LOCAL_DATA_WORDS DEFAULT_VALUE 64
set_parameter_property LOCAL_DATA_WORDS DISPLAY_NAME LOCAL_DATA_WORDS
set_parameter_property LOCAL_DATA_WORDS WIDTH 32
set_parameter_property LOCAL_DATA_WORDS TYPE STD_LOGIC_VECTOR
set_parameter_property LOCAL_DATA_WORDS UNITS None
set_parameter_property LOCAL_DATA_WORDS ALLOWED_RANGES 0:256
set_parameter_property LOCAL_DATA_WORDS DESCRIPTION "EMIF AVMM SLAVE (CTRL_AMM_0) WIDTH IN BYTES"
set_parameter_property LOCAL_DATA_WORDS HDL_PARAMETER true
# 
# display items
# 
# 
# connection point reset
# 
add_interface reset reset end
set_interface_property reset associatedClock clock
set_interface_property reset synchronousEdges DEASSERT
set_interface_property reset ENABLED true
add_interface_port reset reset_n reset_n Input 1
# 
# connection point clock
# 
add_interface clock clock end
set_interface_property clock clockRate 0
set_interface_property clock ENABLED true
add_interface_port clock clk clk Input 1
# 
# connection point csr
# 
add_interface csr avalon end
set_interface_property csr addressAlignment DYNAMIC
set_interface_property csr addressUnits WORDS
set_interface_property csr associatedClock clock
set_interface_property csr associatedReset reset
set_interface_property csr burstOnBurstBoundariesOnly false
set_interface_property csr explicitAddressSpan 0
set_interface_property csr holdTime 0
set_interface_property csr isMemoryDevice false
set_interface_property csr isNonVolatileStorage false
set_interface_property csr linewrapBursts false
set_interface_property csr maximumPendingReadTransactions 0
set_interface_property csr printableDevice false
set_interface_property csr readLatency 2
set_interface_property csr readWaitTime 2
set_interface_property csr setupTime 0
set_interface_property csr timingUnits Cycles
set_interface_property csr writeWaitTime 0
set_interface_property csr ENABLED true
add_interface_port csr csr_address address Input 5
add_interface_port csr csr_read read Input 1
add_interface_port csr csr_write write Input 1
add_interface_port csr csr_readdata readdata Output 32
add_interface_port csr csr_writedata writedata Input 32
add_interface_port csr csr_waitrequest waitrequest Output 1
# 
# connection point interrupt_receiver
# 
add_interface interrupt_receiver interrupt start
set_interface_property interrupt_receiver associatedAddressablePoint avalon_master
set_interface_property interrupt_receiver associatedClock clock
set_interface_property interrupt_receiver associatedReset reset
set_interface_property interrupt_receiver irqScheme INDIVIDUAL_REQUESTS
set_interface_property interrupt_receiver ENABLED true
add_interface_port interrupt_receiver irq irq Input 2
# 
# connection point avalon_master
# 
add_interface avalon_master avalon start
set_interface_property avalon_master addressUnits SYMBOLS
set_interface_property avalon_master associatedClock clock
set_interface_property avalon_master associatedReset reset
set_interface_property avalon_master burstOnBurstBoundariesOnly false
set_interface_property avalon_master doStreamReads false
set_interface_property avalon_master doStreamWrites false
set_interface_property avalon_master linewrapBursts false
set_interface_property avalon_master readLatency 0
set_interface_property avalon_master ENABLED true
add_interface_port avalon_master waitrequest_in waitrequest Input 1
add_interface_port avalon_master csn chipselect_n Output 1
add_interface_port avalon_master wen write_n Output 1
add_interface_port avalon_master oen read_n Output 1
add_interface_port avalon_master be byteenable Output 4
add_interface_port avalon_master addr address Output 32
add_interface_port avalon_master wdata writedata Output 32
add_interface_port avalon_master rdata readdata Input 32
# 
# connection point reset_source
# 
add_interface reset_source reset start
set_interface_property reset_source associatedClock clock
set_interface_property reset_source associatedDirectReset ""
set_interface_property reset_source associatedResetSinks ""
set_interface_property reset_source synchronousEdges DEASSERT
set_interface_property reset_source ENABLED true
add_interface_port reset_source reset_out reset Output 1
# 
# connection point conduit_end
# 
#add_interface conduit_end conduit end
#set_interface_property conduit_end associatedClock clock
#set_interface_property conduit_end associatedReset ""
#set_interface_property conduit_end ENABLED true
#
#add_interface_port conduit_end error_mon export Output 1
#add_interface_port conduit_end status_mon export Output 1
#add_interface_port conduit_end cal_success export Input 1
#add_interface_port conduit_end cal_fail export Input 1
add_interface cal_success conduit end
set_interface_property cal_success associatedClock ""
set_interface_property cal_success associatedReset ""
set_interface_property cal_success ENABLED true
set_interface_property cal_success EXPORT_OF ""
set_interface_property cal_success PORT_NAME_MAP ""
set_interface_property cal_success CMSIS_SVD_VARIABLES ""
set_interface_property cal_success SVD_ADDRESS_GROUP ""
add_interface_port cal_success cal_success export Input 1
add_interface cal_fail conduit end
set_interface_property cal_fail associatedClock ""
set_interface_property cal_fail associatedReset ""
set_interface_property cal_fail ENABLED true
set_interface_property cal_fail EXPORT_OF ""
set_interface_property cal_fail PORT_NAME_MAP ""
set_interface_property cal_fail CMSIS_SVD_VARIABLES ""
set_interface_property cal_fail SVD_ADDRESS_GROUP ""
add_interface_port cal_fail cal_fail export Input 1
add_interface error_mon conduit end
set_interface_property error_mon associatedClock ""
set_interface_property error_mon associatedReset ""
set_interface_property error_mon ENABLED true
set_interface_property error_mon EXPORT_OF ""
set_interface_property error_mon PORT_NAME_MAP ""
set_interface_property error_mon CMSIS_SVD_VARIABLES ""
set_interface_property error_mon SVD_ADDRESS_GROUP ""
add_interface_port error_mon error_mon export Output 1
add_interface status_mon conduit end
set_interface_property status_mon associatedClock ""
set_interface_property status_mon associatedReset ""
set_interface_property status_mon ENABLED true
set_interface_property status_mon EXPORT_OF ""
set_interface_property status_mon PORT_NAME_MAP ""
set_interface_property status_mon CMSIS_SVD_VARIABLES ""
set_interface_property status_mon SVD_ADDRESS_GROUP ""
add_interface_port status_mon status_mon export Output 1
