//Filename: cnt_pulse.v
//Anthor: Anna
//Description: count the number of pulses
//revision: 1.0
//revision history: 21-2-19
 
module cnt_pulse (
  input         i_clk,
  input         i_rstn,
  input         i_fm_vcxo_dec,
  input         i_fm_vcxo_inc,
  input         i_clr_inc_dec,
  output        o_inc_decn,
  output [10:0] o_inc_dec_num
);
  
  wire       S_fm_vcxo_dec_pos_edge;
  reg        S_fm_vcxo_dec_d3;
  reg        S_fm_vcxo_dec_d2;
  reg        S_fm_vcxo_dec_d1;
  reg [10:0] S_dec_num;
  reg        S_dec_trigger;
 
  wire       S_fm_vcxo_inc_pos_edge;
  reg        S_fm_vcxo_inc_d3;
  reg        S_fm_vcxo_inc_d2;
  reg        S_fm_vcxo_inc_d1;
  reg [10:0] S_inc_num;
  reg        S_inc_trigger;
 
  wire       S_clr_inc_dec_pos_edge;
  reg        S_clr_inc_dec_d1;

  
  reg        S_clk_div_2_pulse;
 
  assign S_fm_vcxo_dec_pos_edge    = !S_fm_vcxo_dec_d3 && S_fm_vcxo_dec_d2;
  assign S_fm_vcxo_inc_pos_edge    = !S_fm_vcxo_inc_d3 && S_fm_vcxo_inc_d2;  
  assign S_clr_inc_dec_pos_edge    = !S_clr_inc_dec_d1 && i_clr_inc_dec;
  assign o_inc_decn                  = (S_inc_num >= S_dec_num) ? 1'b1: 1'b0;
  assign o_inc_dec_num               = (S_inc_num >= S_dec_num) ? (S_inc_num - S_dec_num): (S_dec_num - S_inc_num);
  
  always @(posedge i_clk or negedge i_rstn)
  begin
    if(!i_rstn)
      S_clk_div_2_pulse <= 1'b0;
    else
      S_clk_div_2_pulse <= ~ S_clk_div_2_pulse;
  end
  
  always @(posedge i_clk or negedge i_rstn)
  begin
    if(!i_rstn) begin
	   S_fm_vcxo_dec_d3 <= 1'b0;
      S_fm_vcxo_dec_d2 <= 1'b0;
		S_fm_vcxo_dec_d1 <= 1'b0;
	 end	
    else if (S_clk_div_2_pulse) begin
	   S_fm_vcxo_dec_d3 <= S_fm_vcxo_dec_d2;
      S_fm_vcxo_dec_d2 <= S_fm_vcxo_dec_d1;
		S_fm_vcxo_dec_d1 <= i_fm_vcxo_dec;
	 end
  end
  
  always @(posedge i_clk or negedge i_rstn)
  begin
    if(!i_rstn) begin
		S_fm_vcxo_inc_d3 <= 1'b0;
		S_fm_vcxo_inc_d2 <= 1'b0;
		S_fm_vcxo_inc_d1 <= 1'b0;
	 end	
    else if (S_clk_div_2_pulse) begin
		S_fm_vcxo_inc_d3 <= S_fm_vcxo_inc_d2;
		S_fm_vcxo_inc_d2 <= S_fm_vcxo_inc_d1;
		S_fm_vcxo_inc_d1 <= i_fm_vcxo_inc;
	 end
  end
  
  always @(posedge i_clk or negedge i_rstn)
  begin
    if(!i_rstn) begin
      S_clr_inc_dec_d1 <= 1'b0;
	 end	
    else 
      S_clr_inc_dec_d1 <= i_clr_inc_dec;
  end
  
  always @(posedge i_clk or negedge i_rstn)
  begin
    if(!i_rstn) begin
      S_dec_num <= 11'd0;
		S_dec_trigger <= 1'b0;
	 end	
    else if (S_clr_inc_dec_pos_edge) begin
      S_dec_num <= 11'd0;
		S_dec_trigger <= 1'b0;
	 end
	 else if (S_fm_vcxo_dec_pos_edge && !S_dec_trigger) begin
	   S_dec_num <= S_dec_num + 1'b1;
		S_dec_trigger <= 1'b1;
	 end
    else begin
	   S_dec_num <= S_dec_num;
		S_dec_trigger <= 1'b0;
	 end
  end

  always @(posedge i_clk or negedge i_rstn)
  begin
    if(!i_rstn) begin
      S_inc_num <= 11'd0;
		S_inc_trigger <= 1'b0;
	 end	
    else if (S_clr_inc_dec_pos_edge) begin
      S_inc_num <= 11'd0;
		S_inc_trigger <= 1'b0;
	 end
	 else if (S_fm_vcxo_inc_pos_edge && !S_inc_trigger) begin
	   S_inc_num <= S_inc_num + 1'b1;
		S_inc_trigger <= 1'b1;
	 end
    else begin
	   S_inc_num <= S_inc_num;
		S_inc_trigger <= 1'b0;
	 end
  end

endmodule
