
derive_pll_clocks
derive_clock_uncertainty

create_clock -name {altera_reserved_tck} -period 41.667 -waveform { 0.000 20.833 } [get_ports {altera_reserved_tck}]
set_input_delay -add_delay  -clock [get_clocks {altera_reserved_tck}]  5.000 [get_ports {altera_reserved_tdi}]
set_input_delay -add_delay  -clock [get_clocks {altera_reserved_tck}]  5.000 [get_ports {altera_reserved_tms}]
set_output_delay -add_delay -fall -max -clock_fall -clock [get_clocks {altera_reserved_tck}]  5.000 [get_ports {altera_reserved_tdo}]
set_clock_groups -asynchronous -group [get_clocks {altera_reserved_tck}] 

 

#clocks
create_clock -name {clk_50m_sysmax} -period 20.000 [get_ports {clk_50m_sysmax}]
create_generated_clock -name {avst_clk} -source { clk_50m_sysmax } -divide_by 1 [get_ports {avst_clk}]
create_generated_clock -name {fm_sysmax_clk} -source { clk_50m_sysmax } -divide_by 5 [get_ports {fm_sysmax_clk}]
create_generated_clock -name FLASH_CLK -source [get_ports {clk_50m_sysmax}] [get_ports {qspi_sclk}]

# QSPI interface - FPGA image
set flash_data_tracemax 0.1
set flash_data_tracemin 0.056
set flash_clk_tracemax 0.083
set flash_clk_tracemin 0.075
set flash_Tsu 2.700
set flash_Th 2.000
set flash_out_max_dly [expr $flash_data_tracemax + $flash_Tsu - $flash_clk_tracemin]
set flash_out_min_dly [expr $flash_data_tracemin - $flash_Th - $flash_clk_tracemax]
set_output_delay -add_delay -max -clock [get_clocks {FLASH_CLK}] $flash_out_max_dly [get_ports {qspi_d0 qspi_d1 qspi_d2 qspi_d3 qspi_csn}]
set_output_delay -add_delay -min -clock [get_clocks {FLASH_CLK}] $flash_out_min_dly [get_ports {qspi_d0 qspi_d1 qspi_d2 qspi_d3 qspi_csn}]

set flash_tco_max 7.000
set flash_tco_min 1.000
set in_max_dly [expr $flash_data_tracemax + $flash_tco_max + $flash_clk_tracemax]
set in_min_dly [expr $flash_data_tracemin + $flash_tco_min + $flash_clk_tracemin]
set_input_delay -add_delay -max -clock [get_clocks {FLASH_CLK}] $in_max_dly [get_ports {qspi_d0 qspi_d1 qspi_d2 qspi_d3}]
set_input_delay -add_delay -min -clock [get_clocks {FLASH_CLK}] $in_min_dly [get_ports {qspi_d0 qspi_d1 qspi_d2 qspi_d3}]

#Center aligned
set avst_data_tracemax 1.288
set avst_data_tracemin 1.102
set avst_clk_tracemax 1.234
set avst_clk_tracemin 1.128
set fpga_Tsu 2.100
set fpga_Th 0.100
set fpga_out_max_dly [expr $avst_data_tracemax + $fpga_Tsu - $avst_clk_tracemin]
set fpga_out_min_dly [expr $avst_data_tracemin - $fpga_Th - $avst_clk_tracemax]
set_output_delay -add_delay -max -clock [get_clocks {avst_clk}] $fpga_out_max_dly [get_ports {avst_d[*] avst_data_valid}]
set_output_delay -add_delay -min -clock [get_clocks {avst_clk}] $fpga_out_min_dly [get_ports {avst_d[*] avst_data_valid}]
set_false_path -from [get_ports {avst_ready}] -to *

#SGP between system max10 and fm85
set SGP_data_tracemax 1.379
set SGP_data_tracemin 1.204
set SGP_clk_tracemax 1.057
set SGP_clk_tracemin 0.966
set fpga_io_Tsu 1
set fpga_io_Th 0.5
set max10_out_max_dly [expr $SGP_data_tracemax + $fpga_io_Tsu - $SGP_clk_tracemin]
set max10_out_min_dly [expr $SGP_data_tracemin - $fpga_io_Th - $SGP_clk_tracemax]
set_output_delay -add_delay -max -clock [get_clocks {fm_sysmax_clk}] $max10_out_max_dly [get_ports {fm_sysmax_sync fm_sysmax_fimo}]
set_output_delay -add_delay -min -clock [get_clocks {fm_sysmax_clk}] $max10_out_min_dly [get_ports {fm_sysmax_sync fm_sysmax_fimo}]

set fpga_tco_max 0.626
set fpga_tco_min 0.6
set max10_in_max_dly [expr $SGP_data_tracemax + $fpga_tco_max + $SGP_clk_tracemax]
set max10_in_min_dly [expr $SGP_data_tracemin + $fpga_tco_min + $SGP_clk_tracemin]
set_input_delay -add_delay -max -clock [get_clocks {fm_sysmax_clk}] $max10_in_max_dly [get_ports {fm_sysmax_fomi}]
set_input_delay -add_delay -min -clock [get_clocks {fm_sysmax_clk}] $max10_in_min_dly [get_ports {fm_sysmax_fomi}]


#I2C
set_input_delay  -clock { clk_50m_sysmax } 5   [get_ports {sdm_i2c_sda}]
set_input_delay  -clock { clk_50m_sysmax } 5   [get_ports {sdm_i2c_scl}]
set_output_delay -clock { clk_50m_sysmax } 2.5 [get_ports {sdm_i2c_sda}]
set_output_delay -clock { clk_50m_sysmax } 2.5 [get_ports {sdm_i2c_scl}]

set_input_delay  -clock { clk_50m_sysmax } 5   [get_ports {pmb_i2c_sda}]
set_input_delay  -clock { clk_50m_sysmax } 5   [get_ports {pmb_i2c_scl}]
set_output_delay -clock { clk_50m_sysmax } 2.5 [get_ports {pmb_i2c_sda}]
set_output_delay -clock { clk_50m_sysmax } 2.5 [get_ports {pmb_i2c_scl}]

set_input_delay  -clock { clk_50m_sysmax } 5   [get_ports {tsns_i2c_sda}]
set_input_delay  -clock { clk_50m_sysmax } 5   [get_ports {tsns_i2c_scl}]
set_output_delay -clock { clk_50m_sysmax } 2.5 [get_ports {tsns_i2c_sda}]
set_output_delay -clock { clk_50m_sysmax } 2.5 [get_ports {tsns_i2c_scl}]

set_input_delay  -clock { clk_50m_sysmax } 5   [get_ports {ivsns_i2c_sda}]
set_input_delay  -clock { clk_50m_sysmax } 5   [get_ports {ivsns_i2c_scl}]
set_output_delay -clock { clk_50m_sysmax } 2.5 [get_ports {ivsns_i2c_sda}]
set_output_delay -clock { clk_50m_sysmax } 2.5 [get_ports {ivsns_i2c_scl}]

set_input_delay  -clock { clk_50m_sysmax } 5   [get_ports {vcxo_i2c_sda}]
set_input_delay  -clock { clk_50m_sysmax } 5   [get_ports {vcxo_i2c_scl}]
set_output_delay -clock { clk_50m_sysmax } 2.5 [get_ports {vcxo_i2c_sda}]
set_output_delay -clock { clk_50m_sysmax } 2.5 [get_ports {vcxo_i2c_scl}]

set_input_delay  -clock { clk_50m_sysmax } 5   [get_ports {clk_i2c_sda}]
set_input_delay  -clock { clk_50m_sysmax } 5   [get_ports {clk_i2c_scl}]
set_output_delay -clock { clk_50m_sysmax } 2.5 [get_ports {clk_i2c_sda}]
set_output_delay -clock { clk_50m_sysmax } 2.5 [get_ports {clk_i2c_scl}]

set_input_delay  -clock { clk_50m_sysmax } 5   [get_ports {fmca_i2c_sda}]
set_input_delay  -clock { clk_50m_sysmax } 5   [get_ports {fmca_i2c_scl}]
set_output_delay -clock { clk_50m_sysmax } 2.5 [get_ports {fmca_i2c_sda}]
set_output_delay -clock { clk_50m_sysmax } 2.5 [get_ports {fmca_i2c_scl}]

set_input_delay  -clock { clk_50m_sysmax } 5   [get_ports {fmcb_i2c_sda}]
set_input_delay  -clock { clk_50m_sysmax } 5   [get_ports {fmcb_i2c_scl}]
set_output_delay -clock { clk_50m_sysmax } 2.5 [get_ports {fmcb_i2c_sda}]
set_output_delay -clock { clk_50m_sysmax } 2.5 [get_ports {fmcb_i2c_scl}]

set_input_delay  -clock { clk_50m_sysmax } 5   [get_ports {sys_max10_i2c_sda}]
set_input_delay  -clock { clk_50m_sysmax } 5   [get_ports {sys_max10_i2c_scl}]
set_output_delay -clock { clk_50m_sysmax } 2.5 [get_ports {sys_max10_i2c_sda}]
set_output_delay -clock { clk_50m_sysmax } 2.5 [get_ports {sys_max10_i2c_scl}]

set_input_delay  -clock { clk_50m_sysmax } 5   [get_ports {sys_pwr_rsv1}]
set_input_delay  -clock { clk_50m_sysmax } 5   [get_ports {sys_pwr_rsv0}]
set_output_delay -clock { clk_50m_sysmax } 2.5 [get_ports {sys_pwr_rsv1}]
set_output_delay -clock { clk_50m_sysmax } 2.5 [get_ports {sys_pwr_rsv0}]

set_input_delay  -clock { clk_50m_sysmax } 5   [get_ports {pcie_sda_a}]
set_input_delay  -clock { clk_50m_sysmax } 5   [get_ports {pcie_scl_a}]
set_output_delay -clock { clk_50m_sysmax } 2.5 [get_ports {pcie_sda_a}]
set_output_delay -clock { clk_50m_sysmax } 2.5 [get_ports {pcie_scl_a}]

#input port
set_false_path -from [get_ports {sys_max_resetn_conf_done}] -to *
set_false_path -from [get_ports {fpga_msel[0]            }] -to *
set_false_path -from [get_ports {fpga_msel[1]            }] -to *
set_false_path -from [get_ports {fpga_msel[2]            }] -to *
set_false_path -from [get_ports {fpga_nstatus            }] -to *
set_false_path -from [get_ports {sdm_io11                }] -to *
set_false_path -from [get_ports {hps_hw_rstn             }] -to *
#set_false_path -from [get_ports {fc_prsntn               }] -to *
set_false_path -from [get_ports {sys_pwr_ok              }] -to *
set_false_path -from [get_ports {overtemp_n              }] -to *
set_false_path -from [get_ports {pcie_perstn_a           }] -to *
set_false_path -from [get_ports {fmca_pcie_perstn_3v3    }] -to *
set_false_path -from [get_ports {fmcb_pcie_perstn_3v3    }] -to *
set_false_path -from [get_ports {vcxo_fs_1v2             }] -to *
set_false_path -from [get_ports {fm_vcxo_inc             }] -to *
set_false_path -from [get_ports {fm_vcxo_dec             }] -to *
set_false_path -from [get_ports {si5394_lol              }] -to *
set_false_path -from [get_ports {si5394_int_n            }] -to *
set_false_path -from [get_ports {gpio0_ac0_zl_intn       }] -to *
set_false_path -from [get_ports {ptp_clk_lol             }] -to *
set_false_path -from [get_ports {f_gpio[2]                }] -to *
set_false_path -from [get_ports {f_gpio[3]                }] -to *
set_false_path -from [get_ports {f_gpio[4]                }] -to *
set_false_path -from [get_ports {sdm_io16                }] -to *
set_false_path -from [get_ports {sysmax_pb[0]            }] -to *
set_false_path -from [get_ports {sysmax_pb[1]            }] -to *
set_false_path -from [get_ports {sysmax_pb[2]            }] -to *
set_false_path -from [get_ports {sysmax_pb[3]            }] -to *
set_false_path -from [get_ports {sysmax_pb[4]            }] -to *
set_false_path -from [get_ports {sysmax_pb[5]            }] -to *
set_false_path -from [get_ports {sysmax_sw[0]            }] -to *
set_false_path -from [get_ports {sysmax_sw[1]            }] -to *
set_false_path -from [get_ports {sysmax_sw[2]            }] -to *
set_false_path -from [get_ports {sysmax_sw[3]            }] -to *
set_false_path -from [get_ports {sysmax_sw[4]            }] -to *
set_false_path -from [get_ports {sysmax_sw[5]            }] -to *
set_false_path -from [get_ports {sysmax_sw[6]            }] -to *
set_false_path -from [get_ports {sysmax_sw[7]            }] -to *
set_false_path -from [get_ports {mux_dip_sw[0]           }] -to *
set_false_path -from [get_ports {mux_dip_sw[1]           }] -to *
set_false_path -from [get_ports {mux_dip_sw[2]           }] -to *
set_false_path -from [get_ports {mux_dip_sw[3]           }] -to *
set_false_path -from [get_ports {mux_dip_sw[4]           }] -to *
set_false_path -from [get_ports {mux_dip_sw[5]           }] -to *
set_false_path -from [get_ports {mux_dip_sw[6]           }] -to *
set_false_path -from [get_ports {mux_dip_sw[7]           }] -to *
set_false_path -from [get_ports {mux_dip_sw[8]           }] -to *
set_false_path -from [get_ports {mux_dip_sw[9]           }] -to *
set_false_path -from [get_ports {mux_dip_sw[10]          }] -to *
set_false_path -from [get_ports {mux_dip_sw[11]          }] -to *
set_false_path -from [get_ports {user_sw[0]              }] -to *
set_false_path -from [get_ports {user_sw[1]              }] -to *
set_false_path -from [get_ports {user_sw[2]              }] -to *
set_false_path -from [get_ports {user_sw[3]              }] -to *
set_false_path -from [get_ports {user_sw[4]              }] -to *
set_false_path -from [get_ports {user_sw[5]              }] -to *
set_false_path -from [get_ports {user_sw[6]              }] -to *
set_false_path -from [get_ports {user_sw[7]              }] -to *
set_false_path -from [get_ports {user_pb[0]              }] -to *
set_false_path -from [get_ports {user_pb[1]              }] -to *

#output port
set_false_path -from * -to [get_ports {sdm_io11        }]
set_false_path -from * -to [get_ports {sys_pwr_rsv2    }]
set_false_path -from * -to [get_ports {fc_rstn         }]
set_false_path -from * -to [get_ports {fpga_resetn     }]
set_false_path -from * -to [get_ports {s2p_ovtmp_n       }]
set_false_path -from * -to [get_ports {pcie_perstn_a   }]
set_false_path -from * -to [get_ports {fmca_pcie_perstn_3v3}]
set_false_path -from * -to [get_ports {fmcb_pcie_perstn_3v3}]
set_false_path -from * -to [get_ports {r_13a_perst_io_n}]
set_false_path -from * -to [get_ports {r_12a_perst_io_n}]
set_false_path -from * -to [get_ports {r_12c_perst_io_n}]
set_false_path -from * -to [get_ports {sdm_i2c_en      }]
set_false_path -from * -to [get_ports {zl_i2c_en       }]
set_false_path -from * -to [get_ports {clk_i2c_en0     }]
set_false_path -from * -to [get_ports {clk_i2c_en1     }]
set_false_path -from * -to [get_ports {vcxo_fs_3v3     }]
set_false_path -from * -to [get_ports {si5391_oen      }]
set_false_path -from * -to [get_ports {si5391_rstn     }]
set_false_path -from * -to [get_ports {si5391_b_oen    }]
set_false_path -from * -to [get_ports {si5391_b_rstn   }]
set_false_path -from * -to [get_ports {si5332_1_in[2]  }]
set_false_path -from * -to [get_ports {si5332_1_in[1]  }]
set_false_path -from * -to [get_ports {si5332_1_in[0]  }]
set_false_path -from * -to [get_ports {si5394_rstn  }]
set_false_path -from * -to [get_ports {si5394_oe_n  }]
set_false_path -from * -to [get_ports {ptp_clk_rst_n  }]
set_false_path -from * -to [get_ports {mux_sel[14]      }]
set_false_path -from * -to [get_ports {mux_sel[13]      }]
set_false_path -from * -to [get_ports {mux_sel[12]      }]
set_false_path -from * -to [get_ports {mux_sel[11]      }]
set_false_path -from * -to [get_ports {mux_sel[10]      }]
set_false_path -from * -to [get_ports {mux_sel[9]      }]
set_false_path -from * -to [get_ports {mux_sel[8]      }]
set_false_path -from * -to [get_ports {mux_sel[7]      }]
set_false_path -from * -to [get_ports {mux_sel[6]      }]
set_false_path -from * -to [get_ports {mux_sel[5]      }]
set_false_path -from * -to [get_ports {mux_sel[4]      }]
set_false_path -from * -to [get_ports {mux_sel[3]      }]
set_false_path -from * -to [get_ports {mux_sel[2]      }]
set_false_path -from * -to [get_ports {mux_sel[1]      }]
set_false_path -from * -to [get_ports {mux_sel[0]      }]
set_false_path -from * -to [get_ports {dimm_io_en      }]
set_false_path -from * -to [get_ports {mux_sel_zl   }]
set_false_path -from * -to [get_ports {mcio_clk_sel_epn     }]
set_false_path -from * -to [get_ports {mcio_clk_enn   }]
set_false_path -from * -to [get_ports {usb_mux_reset     }]
set_false_path -from * -to [get_ports {usb2_resetn     }]
set_false_path -from * -to [get_ports {fan_rpm         }]
#set_false_path -from * -to [get_ports {opt_fan_rpm     }]
set_false_path -from * -to [get_ports {f_gpio[0]       }]
set_false_path -from * -to [get_ports {f_gpio[1]       }]
set_false_path -from * -to [get_ports {f_gpio[5]       }]
set_false_path -from * -to [get_ports {fpga_nconfig    }]
set_false_path -from * -to [get_ports {sysmax_led_g[0] }]
set_false_path -from * -to [get_ports {sysmax_led_g[1] }]
set_false_path -from * -to [get_ports {sysmax_led_g[2] }]
set_false_path -from * -to [get_ports {sysmax_led_g[3] }]
set_false_path -from * -to [get_ports {sysmax_led_g[4] }]
set_false_path -from * -to [get_ports {sysmax_led_g[5] }]
set_false_path -from * -to [get_ports {sysmax_led_r[0] }]
set_false_path -from * -to [get_ports {sysmax_led_r[1] }]
set_false_path -from * -to [get_ports {user_led_g[0]   }]
set_false_path -from * -to [get_ports {user_led_g[1]   }]
set_false_path -from * -to [get_ports {user_led_g[2]   }]
set_false_path -from * -to [get_ports {user_led_g[3]   }]
set_false_path -from * -to [get_ports {user_led_g[4]   }]
set_false_path -from * -to [get_ports {user_led_g[5]   }]
set_false_path -from * -to [get_ports {user_led_r[0]   }]
set_false_path -from * -to [get_ports {user_led_r[1]   }]
set_false_path -from * -to [get_ports {ca_13c_gxf_io_dfx_1}]
