// pfl2.v

// Generated using ACDS version 22.1 915

`timescale 1 ps / 1 ps
module pfl2 (
		output wire        avst_valid,               //            avalon_source.valid
		input  wire        avst_ready,               //                         .ready
		output wire [31:0] avst_data,                //                         .data
		output wire        avst_clk,                 //                 avst_clk.avst_clk
		inout  wire        flash_io0,                //                flash_io0.flash_io0
		inout  wire        flash_io1,                //                flash_io1.flash_io1
		inout  wire        flash_io2,                //                flash_io2.flash_io2
		inout  wire        flash_io3,                //                flash_io3.flash_io3
		output wire        flash_ncs,                //                flash_ncs.flash_ncs
		output wire        flash_sck,                //                flash_sck.flash_sck
		input  wire        fpga_conf_done,           //           fpga_conf_done.fpga_conf_done
		output wire        fpga_nconfig,             //             fpga_nconfig.fpga_nconfig
		input  wire        fpga_nstatus,             //             fpga_nstatus.fpga_nstatus
		input  wire [2:0]  fpga_pgm,                 //                 fpga_pgm.fpga_pgm
		input  wire        pfl_clk,                  //                  pfl_clk.clk
		input  wire        pfl_flash_access_granted, // pfl_flash_access_granted.pfl_flash_access_granted
		output wire        pfl_flash_access_request, // pfl_flash_access_request.pfl_flash_access_request
		input  wire        pfl_nreconfigure,         //         pfl_nreconfigure.pfl_nreconfigure
		input  wire        pfl_nreset                //               pfl_nreset.reset_n
	);

	altera_parallel_flash_loader_2 #(
		.ADDR_WIDTH              (28),
		.N_FLASH                 (1),
		.FLASH_MFC               ("Micron"),
		.EXTRA_ADDR_BYTE         (1),
		.FLASH_BURST_EXTRA_CYCLE (0),
		.CONF_DATA_WIDTH         (32),
		.OPTION_START_ADDR       (8192),
		.CONF_WAIT_TIMER_WIDTH   (18),
		.SAFE_MODE_HALT          (0),
		.SAFE_MODE_RETRY         (1),
		.SAFE_MODE_REVERT        (0),
		.SAFE_MODE_REVERT_ADDR   (0),
		.READY_SYNC_STAGES       (2)
	) parallel_flash_loader_2_0 (
		.pfl_clk                  (pfl_clk),                  //                  pfl_clk.clk
		.pfl_nreset               (pfl_nreset),               //               pfl_nreset.reset_n
		.avst_valid               (avst_valid),               //            avalon_source.valid
		.avst_ready               (avst_ready),               //                         .ready
		.avst_data                (avst_data),                //                         .data
		.avst_clk                 (avst_clk),                 //                 avst_clk.avst_clk
		.pfl_flash_access_granted (pfl_flash_access_granted), // pfl_flash_access_granted.pfl_flash_access_granted
		.fpga_pgm                 (fpga_pgm),                 //                 fpga_pgm.fpga_pgm
		.fpga_conf_done           (fpga_conf_done),           //           fpga_conf_done.fpga_conf_done
		.fpga_nstatus             (fpga_nstatus),             //             fpga_nstatus.fpga_nstatus
		.pfl_nreconfigure         (pfl_nreconfigure),         //         pfl_nreconfigure.pfl_nreconfigure
		.pfl_flash_access_request (pfl_flash_access_request), // pfl_flash_access_request.pfl_flash_access_request
		.flash_sck                (flash_sck),                //                flash_sck.flash_sck
		.flash_ncs                (flash_ncs),                //                flash_ncs.flash_ncs
		.flash_io0                (flash_io0),                //                flash_io0.flash_io0
		.flash_io1                (flash_io1),                //                flash_io1.flash_io1
		.flash_io2                (flash_io2),                //                flash_io2.flash_io2
		.flash_io3                (flash_io3),                //                flash_io3.flash_io3
		.fpga_nconfig             (fpga_nconfig)              //             fpga_nconfig.fpga_nconfig
	);

endmodule
