/*******************************************************************************
* Copyright (C) 2001-2025 Altera Corporation
*
* This code and the related documents are Altera copyrighted materials and
* your use of them is governed by the express license under which they were
* provided to you ("License"). Unless the License provides otherwise, you may
* not use, modify, copy, publish, distribute, disclose, or transmit this
* code or the related documents without Altera's prior written permission.
* 
* This code and the related documents are provided as is, with no express
* or implied warranties other than those that are expressly stated in the
* License.
* 
*******************************************************************************/

#ifndef __PRBS_PATTERN_CHECKER_H__
#define __PRBS_PATTERN_CHECKER_H__


// public API to access the hardware
void prbs_checker_set_payload_length (unsigned long base, unsigned long length);
void prbs_checker_enable_infinite_payload_length (unsigned long base);
void prbs_checker_disable_infinite_payload_length (unsigned long base);
void prbs_checker_seed_enable (unsigned long base);
void prbs_checker_enable_stop_on_failure (unsigned long base);
void prbs_checker_disable_stop_on_failure (unsigned long base);
void prbs_checker_enable_start (unsigned long base);
void prbs_checker_disable_start (unsigned long base);
void prbs_checker_set_polynomial (unsigned long base, unsigned char *polynomial, long polynomial_length);

unsigned long prbs_checker_read_payload_length (unsigned long base);
unsigned char prbs_checker_read_infinite_payload_length (unsigned long base);
unsigned char prbs_checker_read_stop_on_failure (unsigned long base);
unsigned char prbs_checker_read_start (unsigned long base);
unsigned char prbs_checker_read_failure_detected (unsigned long base);
void prbs_generator_read_polynomial (unsigned long base, unsigned char *polynomial, long polynomial_length);

void prbs_checker_clear_failure (unsigned long base);

#endif /* __PRBS_PATTERN_CHECKER_H__ */


