# Copyright (C) 2001-2025 Altera Corporation
#
# This code and the related documents are Altera copyrighted materials and
# your use of them is governed by the express license under which they were
# provided to you ("License"). Unless the License provides otherwise, you may
# not use, modify, copy, publish, distribute, disclose, or transmit this
# code or the related documents without Altera's prior written permission.
# 
# This code and the related documents are provided as is, with no express
# or implied warranties other than those that are expressly stated in the
# License.


#**************************************************************
# Create Clock
#**************************************************************
derive_pll_clocks
derive_clock_uncertainty
 
create_clock -name {clk_gpio_p_4} -period 10.000 -waveform {0 5} {clk_gpio_p_4}
create_clock -name {fpga_sgpio_clk} -period 100.000 -waveform {0 50} {fpga_sgpio_clk}
create_clock -name {altera_reserved_tck} -period 41.667 [get_ports { altera_reserved_tck }]
#**************************************************************
# Create Generated Clock
#**************************************************************
create_generated_clock -name {clk_50m} -source [get_nets {sys_pll_inst|iopll_0|outclk_0}] 
create_generated_clock -name {clk_25m} -source [get_nets {sys_pll_inst|iopll_0|outclk_1}] 
#**************************************************************
# Set Clock Latency
#**************************************************************
#**************************************************************
# Set Clock Uncertainty
#**************************************************************
#**************************************************************
# Set Input Delay
#**************************************************************
set_input_delay -clock altera_reserved_tck 6 [get_ports altera_reserved_tdi]
set_input_delay -clock altera_reserved_tck 6 [get_ports altera_reserved_tms]
set_input_delay  -clock { clk_50m } 5   [get_ports {clk_i2c_sda_1v2}]
set_input_delay  -clock { clk_50m } 5   [get_ports {clk_i2c_scl_1v2}]
set_output_delay -clock { clk_50m } 2.5 [get_ports {clk_i2c_sda_1v2}]
set_output_delay -clock { clk_50m } 2.5 [get_ports {clk_i2c_scl_1v2}]
set_input_delay  -clock { clk_50m } 5   [get_ports {zl_i2c_sda_1v2}]
set_input_delay  -clock { clk_50m } 5   [get_ports {zl_i2c_scl_1v2}]
set_output_delay -clock { clk_50m } 2.5 [get_ports {zl_i2c_sda_1v2}]
set_output_delay -clock { clk_50m } 2.5 [get_ports {zl_i2c_scl_1v2}]
set_input_delay  -clock { clk_50m } 5   [get_ports {sdi_sda_1v2}]
set_input_delay  -clock { clk_50m } 5   [get_ports {sdi_scl_1v2}]
set_output_delay -clock { clk_50m } 2.5 [get_ports {sdi_sda_1v2}]
set_output_delay -clock { clk_50m } 2.5 [get_ports {sdi_scl_1v2}]
set_input_delay  -clock { clk_50m } 5   [get_ports {ddr4_dimm_2_sda_1v2}]
set_input_delay  -clock { clk_50m } 5   [get_ports {ddr4_dimm_2_scl_1v2}]
set_output_delay -clock { clk_50m } 2.5 [get_ports {ddr4_dimm_2_sda_1v2}]
set_output_delay -clock { clk_50m } 2.5 [get_ports {ddr4_dimm_2_scl_1v2}]
set_input_delay  -clock { clk_50m } 5   [get_ports {vcxo_sda_1v2}]
set_input_delay  -clock { clk_50m } 5   [get_ports {vcxo_scl_1v2}]
set_output_delay -clock { clk_50m } 2.5 [get_ports {vcxo_sda_1v2}]
set_output_delay -clock { clk_50m } 2.5 [get_ports {vcxo_scl_1v2}]
set_input_delay  -clock { clk_50m } 5   [get_ports {i2c_qsfpdd0_sda}]
set_input_delay  -clock { clk_50m } 5   [get_ports {i2c_qsfpdd0_scl}]
set_output_delay -clock { clk_50m } 2.5 [get_ports {i2c_qsfpdd0_sda}]
set_output_delay -clock { clk_50m } 2.5 [get_ports {i2c_qsfpdd0_scl}]
set_input_delay  -clock { clk_50m } 5   [get_ports {i2c_qsfpdd1_sda}]
set_input_delay  -clock { clk_50m } 5   [get_ports {i2c_qsfpdd1_scl}]
set_output_delay -clock { clk_50m } 2.5 [get_ports {i2c_qsfpdd1_sda}]
set_output_delay -clock { clk_50m } 2.5 [get_ports {i2c_qsfpdd1_scl}]
set_input_delay  -clock { clk_50m } 5   [get_ports {i2c_qsfpdd800_sda}]
set_input_delay  -clock { clk_50m } 5   [get_ports {i2c_qsfpdd800_scl}]
set_output_delay -clock { clk_50m } 2.5 [get_ports {i2c_qsfpdd800_sda}]
set_output_delay -clock { clk_50m } 2.5 [get_ports {i2c_qsfpdd800_scl}]
set_input_delay  -clock { clk_50m } 5   [get_ports {i2c_fmcb_sda}]
set_input_delay  -clock { clk_50m } 5   [get_ports {i2c_fmcb_scl}]
set_output_delay -clock { clk_50m } 2.5 [get_ports {i2c_fmcb_sda}]
set_output_delay -clock { clk_50m } 2.5 [get_ports {i2c_fmcb_scl}]
set_input_delay  -clock { clk_50m } 5   [get_ports {i2c_fmca_sda}]
set_input_delay  -clock { clk_50m } 5   [get_ports {i2c_fmca_scl}]
set_output_delay -clock { clk_50m } 2.5 [get_ports {i2c_fmca_sda}]
set_output_delay -clock { clk_50m } 2.5 [get_ports {i2c_fmca_scl}]
set_input_delay -add_delay -max -clock_fall -clock [get_clocks {fpga_sgpio_clk}]  6 [get_ports {fpga_sgpi}]
set_input_delay -add_delay -min -clock_fall -clock [get_clocks {fpga_sgpio_clk}]  5 [get_ports {fpga_sgpi}]
set_input_delay -add_delay -max -clock_fall -clock [get_clocks {fpga_sgpio_clk}]  6 [get_ports {fpga_sgpio_sync}]
set_input_delay -add_delay -min -clock_fall -clock [get_clocks {fpga_sgpio_clk}]  5 [get_ports {fpga_sgpio_sync}]
 
#**************************************************************
# Set Output Delay
#**************************************************************
set_output_delay -clock altera_reserved_tck -clock_fall -max 6 [get_ports altera_reserved_tdo]
set_output_delay -clock { clk_25m } 0.5 [get_ports {inc_pulse}]
set_output_delay -clock { clk_25m } 0.5 [get_ports {dec_pulse}]
set_output_delay -add_delay -max -clock_fall -clock [get_clocks {fpga_sgpio_clk}]  2 [get_ports {fpga_sgpo}]
set_output_delay -add_delay -min -clock_fall -clock [get_clocks {fpga_sgpio_clk}]  0.7 [get_ports {fpga_sgpo}]
#**************************************************************
# Set Clock Groups
#**************************************************************
set_clock_groups -asynchronous -group [get_clocks {altera_reserved_tck}]  
set_clock_groups -asynchronous -group [get_clocks {clk_gpio_p_4}]
set_clock_groups -asynchronous -group [get_clocks {fpga_sgpio_clk}]
#**************************************************************
# Set False Path
#**************************************************************
set_false_path -from [get_ports {fpga_resetn}] -to * 
set_false_path -from [get_ports {qsfpp0_modprs_l}] -to * 
set_false_path -from [get_ports {qsfpp1_modprs_l}] -to * 
set_false_path -from [get_ports {qsfpp800_modprs_l}] -to * 
set_false_path -from [get_ports {f_gpio0}] -to * 
set_false_path -from [get_ports {f_gpio1}] -to * 
set_false_path -from * -to [get_ports {qsfpdd0_modsel_l}]  
set_false_path -from * -to [get_ports {qsfpdd1_modsel_l}]  
set_false_path -from * -to [get_ports {qsfpdd800_modsel_l}] 
set_false_path -from * -to [get_ports {f_gpio2}]  
set_false_path -from * -to [get_ports {f_gpio3}]  
set_false_path -from * -to [get_ports {f_gpio4}]    
#**************************************************************
# Set Multicycle Path
#**************************************************************
#**************************************************************
# Set Maximum Delay
#**************************************************************
#**************************************************************
# Set Minimum Delay
#**************************************************************
#**************************************************************
# Set Input Transition
#**************************************************************